genindex.sh: include the md5_hex hash of lc(owner) in gitproj.list
[girocco.git] / shlib.sh
blobfb93226c03b0e179a338ad594271086c9ea4e5e8
1 #!/bin/sh
3 # This is generic shell library for all the scripts used by Girocco;
4 # most importantly, it introduces all the $cfg_* shell variables.
6 # SHA-1 pattern
7 octet='[0-9a-f][0-9a-f]'
8 octet4="$octet$octet$octet$octet"
9 octet19="$octet4$octet4$octet4$octet4$octet$octet$octet"
10 octet20="$octet4$octet4$octet4$octet4$octet4"
12 vcmp() {
13 # Compare $1 to $2 each of which must match \d+(\.\d+)*
14 # An empty string ('') for $1 or $2 is treated like 0
15 # Outputs:
16 # -1 if $1 < $2
17 # 0 if $1 = $2
18 # 1 if $1 > $2
19 # Note that `vcmp 1.8 1.8.0.0.0.0` correctly outputs 0.
20 while
21 _a="${1%%.*}"
22 _b="${2%%.*}"
23 [ -n "$_a" -o -n "$_b" ]
25 if [ "${_a:-0}" -lt "${_b:-0}" ]; then
26 echo -1
27 return
28 elif [ "${_a:-0}" -gt "${_b:-0}" ]; then
29 echo 1
30 return
32 _a2="${1#$_a}"
33 _b2="${2#$_b}"
34 set -- "${_a2#.}" "${_b2#.}"
35 done
36 echo 0
39 get_girocco_config_pm_var_list() {
40 # Export all the variables from Girocco::Config to suitable var= lines
41 # prefixing them with 'cfg_'. E.g. $cfg_admin is admin's mail address now
42 # and also setting a 'defined_cfg_' prefix to 1 if they are not undef.
43 __girocco_conf="$GIROCCO_CONF"
44 [ -n "$__girocco_conf" ] || __girocco_conf="Girocco::Config"
45 [ -z "$basedir" ] || __girocco_extrainc="-I$basedir"
46 perl -I@basedir@ $__girocco_extrainc -M$__girocco_conf -le \
47 'foreach (sort {uc($a) cmp uc($b)} keys %Girocco::Config::) {
48 my $val = ${$Girocco::Config::{$_}}; defined($val) or $val="";
49 $val =~ s/([\\"\$\`])/\\$1/gos;
50 $val =~ s/(?:\r\n|\r|\n)$//os;
51 print "cfg_$_=\"$val\"";
52 print "defined_cfg_$_=",
53 (defined(${$Girocco::Config::{$_}})?"1":"");
57 get_girocco_config_var_list() (
58 # Same as get_girocco_config_pm_var_list except that
59 # the following variables (all starting with var_) are added:
60 # var_git_ver The version number part from `git version`
61 # var_have_git_172 Set to 1 if git version >= 1.7.2 otherwise ''
62 _cfg_vars="$(get_girocco_config_pm_var_list)"
63 eval "$_cfg_vars"
64 printf '%s\n' "$_cfg_vars"
65 _gver="$("$cfg_git_bin" version 2>/dev/null | \
66 sed -ne 's/^[^0-9]*\([0-9][0-9]*\(\.[0-9][0-9]*\)*\).*$/\1/p')"
67 printf 'var_git_ver=%s\n' "$_gver"
68 printf "var_have_git_172=%s\n" "$([ $(vcmp "$_gver" 1.7.2) -ge 0 ] && echo 1)"
71 # If basedir has been replaced, and shlib_vars.sh exists, get the config
72 # definitions from it rather than running Perl.
73 if [ "@basedir@" = '@'basedir'@' ] || ! [ -r "@basedir@/shlib_vars.sh" ]; then
74 # Import all the variables from Girocco::Config to the local environment,
75 eval "$(get_girocco_config_var_list)"
76 else
77 # Import the variables from shlib_vars.sh which avoids needlessly
78 # running another copy of Perl
79 . "@basedir@/shlib_vars.sh"
82 # Make sure we have a reproducible environment by using a controlled HOME dir
83 XDG_CONFIG_HOME="$cfg_chroot/var/empty"
84 HOME="$cfg_chroot/etc/girocco"
85 GIT_CONFIG_NOSYSTEM=1
86 GIT_ATTR_NOSYSTEM=1
87 GIT_TERMINAL_PROMPT=0
88 GIT_ASKPASS="$cfg_basedir/bin/git-askpass-password"
89 export XDG_CONFIG_HOME
90 export HOME
91 export GIT_CONFIG_NOSYSTEM
92 export GIT_ATTR_NOSYSTEM
93 export GIT_TERMINAL_PROMPT
94 export GIT_ASKPASS
95 unset GIT_USER_AGENT
96 unset GIT_HTTP_USER_AGENT
97 if [ -n "$defined_cfg_git_client_ua" ]; then
98 GIT_USER_AGENT="$cfg_git_client_ua"
99 export GIT_USER_AGENT
100 GIT_HTTP_USER_AGENT="$cfg_git_client_ua"
101 export GIT_HTTP_USER_AGENT
104 # We cannot use a git() {} or nc_openbsd() {} function to redirect git
105 # and nc_openbsd to the desired executables because when using
106 # "ENV_VAR=xxx func" the various /bin/sh implementations behave in various
107 # different and unexpected ways:
108 # a) treat "ENV_VAR=xxx" like a separate, preceding "export ENV_VAR=xxx"
109 # b) treat "ENV_VAR=xxx" like a separate, prededing "ENV_VAR=xxx"
110 # c) treat "ENV_VAR=xxx" like a temporary setting only while running func
111 # None of these are good. We want a temporary "export ENV_VAR=xxx"
112 # setting only while running func which none of the /bin/sh's do.
114 # Instead we'd like to use an alias that provides the desired behavior without
115 # any of the bad (a), (b) or (c) effects.
117 # However, unfortunately, some of the crazy /bin/sh implementations do not
118 # recognize alias expansions when preceded by variable assignments!
120 # So we are left with git() {} and nc_openbsd() {} functions and in the
121 # case of git() {} we can compensate for (b) and (c) failing to export
122 # but not (a) and (b) persisting the values so the caller will simply
123 # have to beware and explicitly unset any variables that should not persist
124 # beyond the function call itself.
126 git() (
127 [ "${GIT_DIR+set}" = "set" ] && export GIT_DIR
128 [ "${GIT_SSL_NO_VERIFY+set}" = "set" ] && export GIT_SSL_NO_VERIFY
129 [ "${GIT_TRACE_PACKET+set}" = "set" ] && export GIT_TRACE_PACKET
130 [ "${GIT_USER_AGENT+set}" = "set" ] && export GIT_USER_AGENT
131 [ "${GIT_HTTP_USER_AGENT+set}" = "set" ] && export GIT_HTTP_USER_AGENT
132 exec "$cfg_git_bin" "$@"
135 nc_openbsd() { "$cfg_nc_openbsd_bin" "$@"; }
137 _addrlist() {
138 _list=
139 for _addr in "$@"; do
140 [ -z "$_list" ] || _list="$_list, "
141 _list="$_list$_addr"
142 done
143 echo "$_list"
146 _sendmail() {
147 _mailer="${cfg_sendmail_bin:-/usr/sbin/sendmail}"
148 if [ -n "$cfg_sender" ]; then
149 "$_mailer" -i -f "$cfg_sender" "$@"
150 else
151 "$_mailer" -i "$@"
155 mail() {
156 _subject=
157 if [ "$1" = "-s" ]; then
158 shift
159 _subject="$1"
160 shift
163 echo "From: \"$cfg_name\" ($cfg_title) <$cfg_admin>"
164 echo "To: $(_addrlist "$@")"
165 [ -z "$_subject" ] || echo "Subject: $_subject"
166 echo "MIME-Version: 1.0"
167 echo "Content-Type: text/plain; charset=utf-8"
168 echo "Content-Transfer-Encoding: 8bit"
169 echo "Auto-Submitted: auto-generated"
170 echo ""
172 } | _sendmail "$@"
175 # bang CMD... will execute the command with well-defined failure mode;
176 # set bang_action to string of the failed action ('clone', 'update', ...);
177 # pre-set bang_once=1 to make sure jobs banging on a repo repeatedly will
178 # not spam the owner; re-define the bang_trap() function to do custom
179 # cleanup before bailing out
180 bang() {
181 if [ -n "$show_progress" ]; then
182 exec 3>&1
183 errcode=
184 read -r errcode <<-EOT || :
186 exec 4>&3 3>&1 1>&4 4>&-
187 { "$@" 3>&- || echo $? >&3; } 2>&1 | tee -a "$bang_log"
190 exec 3>&-
191 if [ -z "$errcode" ]; then
192 # All right. Cool.
193 return;
195 else
196 if "$@" >>"$bang_log" 2>&1; then
197 # All right. Cool.
198 return;
199 else
200 errcode="$?"
203 if ! [ -e .banged ] || [ -e .bangagain ]; then
204 rm -f .bangagain
205 bangmailok=true
206 ! [ -f HEAD -a -f config -a -d objects ] ||
207 bangmailok="$(GIT_DIR=. git config --bool gitweb.statusupdates 2>/dev/null || echo true)"
208 bangaddrs=''
209 [ "$bangmailok" = "false" -o -z "$mail" ] || bangaddrs="$mail"
210 [ -z "$cfg_admincc" -o "$cfg_admincc" = "0" -o -z "$cfg_admin" ] ||
211 if [ -z "$bangaddrs" ]; then bangaddrs="$cfg_admin"; else bangaddrs="$bangaddrs,$cfg_admin"; fi
212 [ -z "$bangaddrs" ] ||
214 echo "$* failed with error code $errcode"
215 echo ""
216 [ ! -n "$bang_once" ] || echo "you will not receive any more notifications until recovery"
217 echo "this status message may be disabled on the project admin page"
218 echo ""
219 echo "Log follows:"
220 echo ""
221 cat "$bang_log"
222 } | mail -s "[$cfg_name] $proj $bang_action failed" "$bangaddrs"
224 touch .banged
225 cat "$bang_log" > .banglog
226 bang_trap
227 exit 1
230 # bang_eval CMD... will evaluate the command with well-defined failure mode;
231 # Identical to bang CMD... except the command is eval'd instead of executed.
232 bang_eval() {
233 bang eval "$*"
236 # Default bang settings:
237 bang_setup() {
238 bang_action="lame_programmer"
239 bang_once=
240 bang_trap() { :; }
241 bang_log="$(mktemp -t repomgr-XXXXXX)"
242 trap 'rm -f "$bang_log"' EXIT
243 trap 'exit 130' INT
244 trap 'exit 143' TERM
247 # Remove banged status
248 bang_reset() {
249 rm -f .banged .bangagain .banglog
252 # Check to see if banged status
253 is_banged() {
254 [ -e .banged ]
258 # Progress report - if show_progress is set, shows the given message.
259 progress() {
260 [ ! -n "$show_progress" ] || echo "$@"
264 # Project config accessors; must be run in project directory
265 config_get() {
266 git config "gitweb.$1"
269 config_set() {
270 git config "gitweb.$1" "$2" && chgrp repo config && chmod g+w config
273 config_set_raw() {
274 git config "$1" "$2" && chgrp repo config && chmod g+w config
277 config_get_date_seconds() {
278 _dt="$(config_get "$1" || :)"
279 [ -n "$_dt" ] || return 1
280 _ds="$(perl -I@basedir@ -MGirocco::Util -e "print parse_rfc2822_date('$_dt')")"
281 [ -n "$_ds" ] || return 1
282 echo "$_ds"
285 # Tool for checking whether given number of seconds has not passed yet
286 check_interval() {
287 os="$(config_get_date_seconds "$1")" || return 1
288 ns="$(date +%s)"
289 [ $ns -lt $(($os+$2)) ]
293 # List all Git repositories, with given prefix if specified, one-per-line
294 # All project names starting with _ are always excluded from the result
295 get_repo_list() {
296 if [ -n "$1" ]; then
297 cut -d : -f 1,3 "$cfg_chroot"/etc/group | grep "^$1"
298 else
299 cut -d : -f 1,3 "$cfg_chroot"/etc/group
300 fi | while IFS=: read name id; do
301 [ $id -lt 65536 ] || case "$name" in _*) :;; ?*) echo "$name"; esac
302 done
305 # returns empty string for non-mirrors, otherwise one of:
306 # m => normal Git mirror
307 # s => mirror from svn source
308 # d => mirror from darcs source
309 # b => mirror from bzr source
310 # h => mirror from hg source
311 # the optional passed in git dir defaults to "."
312 # will fail if the directory does not have .nofetch and gitweb.baseurl
313 # comes back empty
314 get_mirror_type() {
315 _gitdir="${1:-.}"
316 # always return empty for non-mirrors
317 [ ! -e "$_gitdir/.nofetch" ] || return 0
318 _url="$(GIT_DIR="$_gitdir" config_get baseurl 2>/dev/null || :)"
319 _url="${_url##* }"
320 case "$_url" in
322 return 1
324 svn://* | svn+http://* | svn+https://*)
325 echo 's'
327 darcs://*)
328 echo 'd'
330 bzr://*)
331 echo 'b'
333 hg+http://* | hg+https://*)
334 echo 'h'
337 echo 'm'
339 esac
340 return 0
343 # returns true if the passed in git dir (defaults to ".") is a mirror using git fast-import
344 is_gfi_mirror() {
345 case "$(get_mirror_type "$1" 2>/dev/null || :)" in
346 d|b|h)
347 # darcs, bzr and hg mirrors use git fast-import
348 return 0
351 # Don't think git-svn currently uses git fast-import
352 # And Git mirrors certainly do not
353 return 1
355 esac
356 # assume it does not use git fast-import
357 return 1
360 # returns true if the passed in git dir (defaults to ".") is a mirror using git-svn
361 is_svn_mirror() {
362 [ "$(get_mirror_type "$1" 2>/dev/null || :)" = "s" ]
365 # A well-known UTF-8 locale is required for some of the fast-import providers
366 # in order to avoid mangling characters. Ideally we could use "POSIX.UTF-8"
367 # but that is not reliably UTF-8 but rather usually US-ASCII.
368 # We parse the output of `locale -a` and select a suitable UTF-8 locale.
369 # If we cannot find one in the `locale -a` output then we just use a well-known
370 # UTF-8 locale and hope for the best. We set LC_ALL to our choice and export
371 # it. We only set this temporarily when running the fast-import providers.
372 set_utf8_locale() {
373 _guess_locale="$(locale -a | grep -viE '^(posix|c)(\..*)?$' | \
374 grep -iE '\.utf-?8$' | sed -e 's/\.[Uu][Tt][Ff]-*8$//' | \
375 sed -e '/en_US/ s/^/0 /; /en_US/ !s/^/1 /' | LC_ALL=C sort | \
376 head -n 1 | cut -d ' ' -f 2)"
377 LC_ALL="${_guess_locale:-en_US}.UTF-8"
378 export LC_ALL
381 # hg-fast-export | git fast-import with error handling in current directory GIT_DIR
382 git_hg_fetch() (
383 set_utf8_locale
384 _python="${PYTHON:-python}"
385 _err1=
386 _err2=
387 exec 3>&1
388 { read -r _err1 || :; read -r _err2 || :; } <<-EOT
390 exec 4>&3 3>&1 1>&4 4>&-
392 _e1=0
393 [ -f hg2git-marks ] || touch hg2git-marks
394 _af="$(git config hg.authorsfile || :)"
395 _cmd='GIT_DIR="$(pwd)" "$_python" "$cfg_basedir/bin/hg-fast-export.py" \
396 --repo "$(pwd)/repo.hg" \
397 --marks "$(pwd)/hg2git-marks" \
398 --mapping "$(pwd)/hg2git-mapping" \
399 --heads "$(pwd)/hg2git-heads" \
400 --status "$(pwd)/hg2git-state" \
401 -U unknown --force --flatten --hg-hash'
402 [ -z "$_af" ] || _cmd="$_cmd"' --authors "$_af"'
403 eval "$_cmd" 3>&- || _e1=$?
404 echo $_e1 >&3
405 } | \
407 _e2=0
408 rm -f hg2git-marks.new
409 git fast-import \
410 --export-marks="$(pwd)/hg2git-marks.new" \
411 --export-pack-edges="$(pwd)/gfi-packs" \
412 --force 3>&- || _e2=$?
413 echo $_e2 >&3
417 exec 3>&-
418 [ "$_err1" = 0 -a "$_err2" = 0 ] || return 1
419 if [ -f hg2git-marks ]; then
420 rm -f hg2git-marks.old
421 mv hg2git-marks hg2git-marks.old
422 else
423 touch hg2git-marks.old
425 cat hg2git-marks.old hg2git-marks.new | \
426 LC_ALL=C sort -t : -k2,2n -u | \
427 sed -ne "/^:[1-9][0-9]* $octet20\$/p" > hg2git-marks
428 rm hg2git-marks.old hg2git-marks.new
429 rm -f hg2git-heads
430 git branch --no-color | \
431 while IFS= read -r _head; do
432 echo ":${_head#??} $(git rev-parse "refs/heads/${_head#??}")"
433 done > hg2git-heads